;CP/M BIOS by Gocaine Project
;This code is unlicensed!
ORG 0F200H
	JP	boot
wboote:	JP	wboot
	JP	const
	JP	conin
	JP	conout
	JP	list
	JP	punch
	JP	reader
	JP	home
	JP	seldsk
	JP	settrk
	JP	setsec
	JP	setdma
	JP	read
	JP	write
	JP	listst	;list status
	JP	sectran

    DB 000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H
disks1:    DB 000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H
    DB 000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H
    DB 000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H
    DB 000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H
    DB 000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H
    DB 000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H,000H

readf	equ	4h	;read function
writf	equ	6h	;write function
recal	equ	3h	;recalibrate drive
iordy	equ	4h	;i/o finished mask
cr	equ	0dh	;carriage return
lf	equ	0ah	;line feed
	
nullfunc:RET

bootmsg:    DB  'Welcome to Gocaine Kiskan Z80 CP/M 2.2',0DH,0AH,'$'

bootmark: DB 000H,000H

boot:
LD SP,0FF00H
PUSH BC
PUSH DE
LD BC,0C126H
LD D,7
OUT (C),D
LD A,(bootmark)
CP 0
JR NZ,wboot
LD DE,bootmsg
LD C,09H
CALL 0005H
LD A,1
PUSH HL
LD HL,bootmark
LD (HL),A
POP HL
POP DE
POP BC

wboot:
PUSH BC
PUSH DE
LD BC,0C302H
LD D,2
OUT (C),D
LD BC,0C303H
LD DE,0DC00H
CALL homeleba
POP DE
POP BC
JP 0DC00H

const:PUSH BC
LD BC,0C301H
IN A,(C)
CP 0
JR NZ,const1
JR const0
const0:
LD A,000H
JR constr
const1:
LD A,0FFH
constr:
POP BC
RET

conin:
PUSH BC
PUSH DE
coninwpbc:
LD BC,0C301H
IN A,(C)
CP 0
JR Z,coninwpbc
LD BC,0C301H
LD D,000H
OUT (C),D
POP DE
POP BC
RET

coninzero:
LD A,0FFH
RET

conout:
PUSH BC
PUSH DE
LD E,C
LD D,10
LD BC,0C130H
OUT (C),E
LD BC,0C127H
OUT (C),D
POP DE
POP BC
RET

list:RET

punch:RET

reader:RET

home:
PUSH BC
PUSH DE
LD BC,0C12CH
;LD DE,128
;CALL homeleba
LD DE,000H
CALL homeleba
LD DE,000H
CALL homeleba
POP DE
POP BC
RET

homeleba:
OUT (C),E
INC BC
OUT (C),D
INC BC
RET

seldsk:
LD A,C
CP 0
JP NZ,seldsknf
LD HL,disks1
RET

seldsknf:LD HL,00000H
RET

settrk:
PUSH BC
PUSH DE
LD D,B
LD E,C
LD BC,0C12CH
CALL homeleba
POP DE
POP BC
RET

setsec:
PUSH BC
PUSH DE
LD D,B
LD E,C
LD BC,0C12EH
CALL homeleba
POP DE
POP BC
RET

setdma:
PUSH BC
PUSH DE
LD D,B
LD E,C
LD BC,0C12AH
CALL homeleba
POP DE
POP BC
RET

read:
PUSH BC
PUSH DE
LD BC,0C128H
LD E,1
OUT (C),E
POP DE
POP BC
LD A,0
RET

write:
PUSH BC
PUSH DE
LD BC,0C128H
LD E,2
OUT (C),E
POP DE
POP BC
LD A,0
RET

listst:LD A,0FFH
RET

sectran:
LD H,B
LD L,C
INC HL
RET

END